VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "cRegions"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit
'
' Regions
'
'---- Aufbau eines RegionFile-Eintrags
'
' Offset  Gre    Beschreibung
'---------------------------------------------
'   0     1 Byte   Typ (0=RECT, 1=ROUND, 2=POLY)
'   1     1 Long   Lnge der Daten in POINTW
'   4     PString  Title/Info
'  ...    PString  Tag
'  ...    ...      Nettodaten
'---------------------------------------------
'PString = (1 Byte + String) len [0...255]
'Nettodaten (RECT/ROUND): 2 * POINTW
'Nettodaten (POLY): n * POINTW

Private Type POINTW
  x As Integer
  y As Integer
End Type

Private Enum RGN_TYP
  RGN_RECT = 0
  RGN_ROUND
  RGN_POLY
End Enum

Private MyRegions As Collection


'==== PUBLIC ====================

Public Property Get Count() As Long
  Count = MyRegions.Count
End Property

Public Function Add() As cRegion
  Set Add = New cRegion
  MyRegions.Add Add
End Function

Public Sub Delete(ByVal Index As Long)
'Region Nr. Index lschen
  With MyRegions
    If (Index > .Count - 1) Then Exit Sub 'falscher index
    .Remove Index + 1
  End With
End Sub

Public Sub Clear()
'alle Regionen lschen
  Dim i As Long
  '
  With MyRegions
    For i = 1 To .Count: .Remove 1: Next
  End With
End Sub

Public Function Item(ByVal Index As Long) As cRegion
'liefert die Region Nr.Index (0-basiert)
  Set Item = Nothing
  With MyRegions
    If (Index > .Count - 1) Then Exit Function 'ungltiger Index
    Set Item = .Item(Index + 1)
  End With
End Function

Public Sub OnTop(ByVal Index As Long)
'setzt Region Nr. index in den Vordergrund
  Dim r As cRegion
  '
  If (MyRegions.Count = 0) Then Exit Sub
  If (Index = 0) Then Exit Sub 'ist bereits im Vordergrund
  Set r = MyRegions.Item(Index + 1)
  MyRegions.Remove Index + 1
  MyRegions.Add r, , 1
End Sub

Public Sub OnBack(ByVal Index As Long)
'setzt Region Nr. index in den Hintergrund
  Dim r As cRegion
  '
  If (MyRegions.Count = 0) Then Exit Sub
  If (Index = MyRegions.Count - 1) Then Exit Sub 'ist bereits im Hintergrund
  Set r = MyRegions.Item(Index + 1)
  MyRegions.Remove Index + 1
  MyRegions.Add r
End Sub

'---- File I/0 --------------------

Public Sub Import(ByVal fname As String)
'Regionen aus Datei lesen
  Dim fh As Long, flen As Long, foff As Long
  Dim i As Long, siz As Long, ty As Byte, b As Byte
  Dim r As cRegion, pw1 As POINTW, pw2 As POINTW
  '
  Clear 'Liste leeren
  fh = FreeFile
  Open fname For Binary Access Read As fh
  flen = LOF(fh) 'Dateilnge holen
  '---- alle Region-Informationen lesen
  foff = 1
  While Not (foff > flen) 'noch Daten zu lesen
    Set r = Add           'neue Region anlegen
    With r
      Get #fh, foff, ty: r.Typ = ty 'Typ lesen
      Get #fh, , siz                'Size lesen
      r.Title = ReadPString(fh)     'Title lesen
      r.Tag = ReadPString(fh)       'Tag lesen
      '---- Daten lesen
      If (ty = RGN_POLY) Then
        For i = 0 To siz - 1
          Get #fh, , pw1 'Punkt lesen
          If (i < 4) Then
            r.SetPoint i, pw1.x, pw1.y
          Else
            r.AddPoint pw1.x, pw1.y
          End If
        Next
        '---- evtl. letzten Punkt entfernen
        If (siz = 3) Then r.DeletePoint 3
      Else '---- RGN_RECT/RGN_ROUND
        Get #fh, , pw1: Get #fh, , pw2 '2 Punkte lesen
        r.SetRect pw1.x, pw1.y, pw2.x, pw2.y 'zuweisen
      End If
      '---- Dateipointer korrigieren
      foff = foff + 7 + Len(r.Title) + Len(r.Tag) + siz * 4
    End With
  Wend
  Close fh
End Sub

Public Sub Export(ByVal fname As String)
'Regionen in Datei schreiben
  Dim fh As Long, flen As Long, foff As Long
  Dim i As Long, j As Long, siz As Long, ty As Byte
  Dim r As cRegion, pw As POINTW
  Dim x1 As Long, y1 As Long, x2 As Long, y2 As Long
  '
  If (MyRegions.Count = 0) Then Exit Sub
  If (FileExist(fname)) Then Kill fname 'Datei entfernen
  fh = FreeFile
  Open fname For Binary Access Write As fh
  '---- alle Region-Informationen schreiben
  For i = 1 To MyRegions.Count
    Set r = MyRegions.Item(i) 'Region holen
    With r
      ty = r.Typ: Put #fh, , ty      'Typ schreiben
      siz = r.Points: Put #fh, , siz 'Size schreiben
      WritePString fh, r.Title       'Title schreiben
      WritePString fh, r.Tag         'Tag schreiben
      '---- Daten schreiben
      If (ty = RGN_POLY) Then
        For j = 0 To siz - 1
          r.GetPoint j, x1, y1: pw.x = x1: pw.y = y1 'Punkt holen
          Put #fh, , pw 'Punkt schreiben
        Next
      Else '---- RGN_RECT/RGN_ROUND
        r.GetRect x1, y1, x2, y2 'rect holen
        pw.x = x1: pw.y = y1: Put #fh, , pw 'Punkt1 schreiben
        pw.x = x2: pw.y = y2: Put #fh, , pw 'Punkt2 schreiben
      End If
    End With
  Next
CLOSEFILE:
  Close fh
End Sub

Public Function CheckRgnFile(ByVal fname As String) As Boolean
'Integritt des RgnFiles testen
  Dim fh As Long, flen As Long, foff As Long
  Dim i As Long, j As Long, ty As Byte, b As Byte
  '
  CheckRgnFile = False
  If (Len(fname) = 0) Then Exit Function
  If (Not FileExist(fname)) Then Exit Function
  fh = FreeFile
  Open fname For Binary Access Read As fh
  flen = LOF(fh) 'Dateilnge holen
  '---- Struktur scannen (Typ,Size,PString,PString,Daten)
  '                        1   4     1+b     1+b    i
  If (flen > 0) Then
    foff = 0
    Do
      'HeaderCheck
      If (foff < 0) Then GoTo CLOSEFILE 'fehlerhafte Struktur
      If (foff + 7 > flen) Then GoTo CLOSEFILE 'fehlerhafte Struktur
      Get #fh, foff + 1, ty   'Typ holen
      If (ty < 0) Or (ty > 2) Then GoTo CLOSEFILE 'fehlerhafter Typ
      Get #fh, foff + 2, i    'Size holen
      If (ty = RGN_POLY) Then 'Polygon mind. 3 Punkte
        If (i < 3) Then GoTo CLOSEFILE 'fehlerhafte Daten
      Else                    'Rect/Round = 2 Punkte
        If Not (i = 2) Then GoTo CLOSEFILE 'fehlerhafte Daten
      End If
      Get #fh, foff + 6, b 'PStringlen (Title) holen
      j = 7 + b
      Get #fh, foff + j, b 'PStringlen (Tag) holen
      j = j + b + i * 4
      If (foff + j = flen) Then Exit Do        'Struktur OK
      If (foff + j > flen) Then GoTo CLOSEFILE 'fehlerhafte Struktur
      foff = foff + j
    Loop
  End If
  CheckRgnFile = True
CLOSEFILE:
  Close fh
End Function


'==== STUFF ====================

Private Function ReadPString(ByVal fh As Long) As String
'PascalString aus File lesen
  Dim b As Byte
  '
  Get #fh, , b 'Lnge lesen
  ReadPString = Space$(b)
  If (b = 0) Then Exit Function
  '---- String lesen
  Get #fh, , ReadPString
End Function

Private Sub WritePString(ByVal fh As Long, _
                         ByVal s As String)
'PascalString in File schreiben
  Dim b As Byte
  '
  b = Len(s)
  Put #fh, , b 'Lnge schreiben
  If (b = 0) Then Exit Sub
  '---- String schreiben
  Put #fh, , s
End Sub

Private Function FileExist(ByVal f As String) As Boolean
On Error GoTo FILEERROR
  FileExist = False
  If (Len(Trim(f)) = 0) Then Exit Function
  If (Asc(Right(f, 1)) = 58) Then Exit Function 'Doppelpunkt
  If (Asc(Right(f, 1)) = 92) Then Exit Function 'Backslash
  FileExist = (Len(Dir(f)) > 0)
FILEERROR:
End Function

'==== CLASS ====================

Private Sub Class_Initialize()
  Set MyRegions = New Collection
End Sub
